﻿@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation
@model Jb.Framework.Common.Forms.JbCheckBox

@{
    var titlevalue = Model.Title;
    var labelHtmlAttr = new Dictionary<string, object> { { "class", "Custom-label pull-left" }, { "data-value", titlevalue } };
    var checkBoxHtmlAttr = new Dictionary<string, object> {};

    checkBoxHtmlAttr.Add("data-clientid", Model.Name);
    if (Model.CurrentMode != AccessMode.Design)
    {
        if (Model.IsRequired || Model.Validations.Any(x => x.Type != ElementValidationType.None))
        {
            checkBoxHtmlAttr.Add("data-val", "true");
        }
        if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
        {
            checkBoxHtmlAttr.Add("data-val-required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
            checkBoxHtmlAttr.Add("required","");
        }
        else if (Model.IsRequired)
        {
            checkBoxHtmlAttr.Add("data-val-required", Model.Title + " is required.");
            checkBoxHtmlAttr.Add("required", "");
        }

        if (Model.CurrentMode == AccessMode.ReadOnly)
        {
            checkBoxHtmlAttr.Add("readonly", true);
        }
    }
}

<div class="form-group JbFormControll JbCheckBox" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
    @Html.Hidden("ModelType", Model.GetType())

    @for (var i = 0; i < Model.Validations.Count; i++)
    {
        @Html.HiddenFor(x => x.Validations[i].Type)
        @Html.HiddenFor(x => x.Validations[i].Message)
    }

    @Html.GenerateHiddenFields(Model)

    @foreach (var accRole in Model.AccessRole)
    {
        @Html.HiddenFor(modelItem => accRole)
    }
    <div class="checkbox">
        @{
            var labelClass = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "";
        }
        <label class="@labelClass">
            @Html.CheckBoxFor(x => x.Value, checkBoxHtmlAttr) <span class="check"></span>
            @Html.DisplayFor(x => x.Title)

            @Html.ValidationMessageFor(model => model.Value)
        </label>
        @if (!string.IsNullOrEmpty(Model.HelpText))
        {
            <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
        }
    </div>
</div>
